## cinder 12.0.10

=== requirements.txt ===
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.

pbr!=2.1.0,>=2.0.0 # Apache-2.0
Babel!=2.4.0,>=2.3.4 # BSD
decorator>=3.4.0 # BSD
defusedxml>=0.5.0 # PSF
enum34>=1.0.4;python_version=='2.7' or python_version=='2.6' or python_version=='3.3' # BSD
eventlet!=0.18.3,!=0.20.1,<0.21.0,>=0.18.2 # MIT
greenlet>=0.4.10 # MIT
httplib2>=0.9.1 # MIT
iso8601>=0.1.11 # MIT
jsonschema<3.0.0,>=2.6.0 # MIT
ipaddress>=1.0.16;python_version<'3.3' # PSF
keystoneauth1>=3.3.0 # Apache-2.0
keystonemiddleware>=4.17.0 # Apache-2.0
lxml!=3.7.0,>=3.4.1 # BSD
oauth2client!=4.0.0,>=1.5.0 # Apache-2.0
oslo.config>=5.1.0 # Apache-2.0
oslo.concurrency>=3.25.0 # Apache-2.0
oslo.context>=2.19.2 # Apache-2.0
oslo.db>=4.27.0 # Apache-2.0
oslo.log>=3.36.0 # Apache-2.0
oslo.messaging>=5.29.0 # Apache-2.0
oslo.middleware>=3.31.0 # Apache-2.0
oslo.policy>=1.30.0 # Apache-2.0
oslo.privsep>=1.23.0 # Apache-2.0
oslo.reports>=1.18.0 # Apache-2.0
oslo.rootwrap>=5.8.0 # Apache-2.0
oslo.serialization!=2.19.1,>=2.18.0 # Apache-2.0
oslo.service!=1.28.1,>=1.24.0 # Apache-2.0
oslo.utils>=3.33.0 # Apache-2.0
oslo.versionedobjects>=1.31.2 # Apache-2.0
osprofiler>=1.4.0 # Apache-2.0
paramiko>=2.0.0 # LGPLv2.1+
Paste>=2.0.2 # MIT
PasteDeploy>=1.5.0 # MIT
PrettyTable<0.8,>=0.7.1 # BSD
psutil>=3.2.2 # BSD
pyparsing>=2.1.0 # MIT
python-barbicanclient!=4.5.0,!=4.5.1,>=4.0.0 # Apache-2.0
python-glanceclient>=2.8.0 # Apache-2.0
python-keystoneclient>=3.8.0 # Apache-2.0
python-novaclient>=9.1.0 # Apache-2.0
python-swiftclient>=3.2.0 # Apache-2.0
pytz>=2013.6 # MIT
requests>=2.14.2 # Apache-2.0
retrying!=1.3.0,>=1.2.3 # Apache-2.0
Routes>=2.3.1 # MIT
taskflow>=2.16.0 # Apache-2.0
rtslib-fb!=2.1.60,!=2.1.61,!=2.1.64,>=2.1.43 # Apache-2.0
simplejson>=3.5.1 # MIT
six>=1.10.0 # MIT
SQLAlchemy!=1.1.5,!=1.1.6,!=1.1.7,!=1.1.8,>=1.0.10 # MIT
sqlalchemy-migrate>=0.11.0 # Apache-2.0
stevedore>=1.20.0 # Apache-2.0
suds-jurko>=0.6 # LGPLv3+
WebOb>=1.7.1 # MIT
oslo.i18n>=3.15.3 # Apache-2.0
oslo.vmware>=2.17.0 # Apache-2.0
os-brick>=2.2.0 # Apache-2.0
os-win>=3.0.0 # Apache-2.0
tooz>=1.58.0 # Apache-2.0
google-api-python-client>=1.4.2 # Apache-2.0
castellan>=0.16.0 # Apache-2.0
cryptography!=2.0,>=1.9 # BSD/Apache-2.0

=== debian/changelog ===
cinder (2:12.0.10-0ubuntu2.2) bionic-security; urgency=medium

  * SECURITY UPDATE: Arbitrary file access
    - debian/patches/CVE-2022-47951.patch: Check VMDK subformat
      against an allowed list.
    - debian/patches/use_json_format.patch: switch qemu_img_info to json
      format.
    - CVE-2022-47951

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 06 Feb 2023 08:05:53 -0500

cinder (2:12.0.10-0ubuntu2) bionic; urgency=medium

  [ Chris MacNaughton ]
  * d/control: Update VCS paths for move to lp:~ubuntu-openstack-dev.

  [ Corey Bryant ]
  * d/p/rbd-retry-delete.patch: Fix RBD mirroring race by retrying volume delete
    if VolumeIsBusy in _copy_image_to_volume (LP: #1900775).

 -- Corey Bryant <corey.bryant@canonical.com>  Tue, 26 Jan 2021 15:56:11 -0500

cinder (2:12.0.10-0ubuntu1) bionic; urgency=medium

  * New stable point release for OpenStack Queens (LP: #1893234).

 -- Chris MacNaughton <chris.macnaughton@canonical.com>  Fri, 28 Aug 2020 11:15:38 +0000

cinder (2:12.0.9-0ubuntu1.2) bionic-security; urgency=medium

  * SECURITY UPDATE: Dell EMC ScaleIO/VxFlex OS Backend Credentials Exposure
    (LP: #1823200)
    - debian/patches/CVE-2020-10755.patch: Remove VxFlex OS credentials
      from connection_properties. Passwords are now stored in separate file
      and are retrieved during each attach/detach operation.
    - d/control: Align (Build-)Depends with min version of python3-os-brick
      required to fix credential exposure.
    - CVE-2020-10755

 -- Corey Bryant <corey.bryant@canonical.com>  Tue, 23 Jun 2020 15:58:12 -0400

=== debian/control ===
Source: cinder
Section: net
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Chuck Short <zulcss@ubuntu.com>
Build-Depends:
 apache2-dev,
 debhelper (>= 10~),
 dh-apache2,
 dh-python,
 openstack-pkg-tools (>= 23~),
 python-all,
 python-pbr (>= 2.0.0),
 python-setuptools,
 python3-sphinx (>= 1.6.2),
Build-Depends-Indep:
 python-babel (>= 2.3.4),
 python-barbicanclient (>= 4.0.0),
 python-castellan (>= 0.14.0),
 python-coverage (>= 4.0),
 python-cryptography (>= 1.9),
 python-ddt (>= 1.0.1),
 python-decorator (>= 3.4.0),
 python-defusedxml (>= 0.5.0),
 python-enum34,
 python-eventlet (>= 0.18.2),
 python-fixtures (>= 3.0.0),
 python-glanceclient (>= 1:2.8.0),
 python-googleapi (>= 1.4.2),
 python-greenlet (>= 0.4.10),
 python-hacking (>= 0.12.0),
 python-httplib2 (>= 0.9.1),
 python-ipaddress (>= 1.0.16),
 python-iso8601 (>= 0.1.11),
 python-keystoneauth1 (>= 3.3.0),
 python-keystoneclient (>= 1:3.8.0),
 python-keystonemiddleware (>= 4.17.0),
 python-lxml (>= 3.4.1),
 python-migrate (>= 0.11.0),
 python-mock (>= 2.0.0),
 python-novaclient (>= 2:9.1.0),
 python-oauth2client (>= 1.5.0),
 python-openstackdocstheme (>= 1.18.1),
 python-os-api-ref (>= 1.0.0),
 python-os-brick (>= 2.3.0-0ubuntu1.1~),
 python-os-win (>= 2.0.0),
 python-oslo.concurrency (>= 3.25.0),
 python-oslo.config (>= 1:5.1.0),
 python-oslo.context (>= 1:2.19.2),
 python-oslo.db (>= 4.27.0),
 python-oslo.i18n (>= 3.15.3),
 python-oslo.log (>= 3.36.0),
 python-oslo.messaging (>= 5.29.0),
 python-oslo.middleware (>= 3.31.0),
 python-oslo.policy (>= 1.30.0),
 python-oslo.privsep (>= 1.23.0),
 python-oslo.reports (>= 1.18.0),
 python-oslo.rootwrap (>= 5.8.0),
 python-oslo.serialization (>= 2.18.0),
 python-oslo.service (>= 1.24.0),
 python-oslo.utils (>= 3.33.0),
 python-oslo.versionedobjects (>= 1.31.2),
 python-oslo.vmware (>= 2.17.0),
 python-oslotest (>= 1.10.0),
 python-osprofiler (>= 1.4.0),
 python-paramiko (>= 2.0.0),
 python-paste (>= 2.0.2),
 python-pastedeploy (>= 1.5.0),
 python-pep8,
 python-prettytable (>= 0.7.1),
 python-psycopg2 (>= 2.5),
 python-pymysql (>= 0.7.6),
 python-pyparsing (>= 2.0.7),
 python-requests (>= 2.14.2),
 python-retrying (>= 1.2.3),
 python-routes (>= 2.3.1),
 python-rtslib-fb (>= 2.1.43),
 python-simplejson (>= 3.5.1),
 python-six (>= 1.10.0),
 python-sqlalchemy (>= 1.0.10),
 python-stestr,
 python-stevedore (>= 1.20.0),
 python-suds (>= 0.6),
 python-swiftclient (>= 1:3.2.0),
 python-taskflow (>= 2.7.0),
 python-tempest (>= 1:16.1.0),
 python-testrepository (>= 0.0.18),
 python-testresources (>= 2.0.0),
 python-testscenarios (>= 0.4),
 python-testtools (>= 2.2.0),
 python-tooz (>= 1.58.0),
 python-tz (>= 2013.6),
 python-webob (>= 1:1.7.1),
Standards-Version: 4.1.2
Homepage: http://launchpad.net/cinder
Vcs-Browser: https://git.launchpad.net/~ubuntu-openstack-dev/ubuntu/+source/cinder
Vcs-Git: git://git.launchpad.net/~ubuntu-openstack-dev/ubuntu/+source/cinder
XS-Testsuite: autopkgtest

Package: cinder-api
Architecture: all
Depends:
 apache2 | httpd,
 cinder-common (= ${binary:Version}),
 libapache2-mod-wsgi,
 ${misc:Depends},
 ${python:Depends},
Description: Cinder storage service - API server
 OpenStack is a reliable cloud infrastructure. Its mission is to produce
 the ubiquitous cloud computing platform that will meet the needs of public
 and private cloud providers regardless of size, by being simple to implement
 and massively scalable.
 .
 Cinder is the OpenStack Block storage service.
 .
 This package contains the Cinder API server.

Package: cinder-backup
Architecture: all
Depends:
 cinder-common (= ${binary:Version}),
 ${misc:Depends},
 ${python:Depends},
Description: Cinder storage service - Scheduler server
 OpenStack is a reliable cloud infrastructure. Its mission is to produce
 the ubiquitous cloud computing platform that will meet the needs of public
 and private cloud providers regardless of size, by being simple to implement
 and massively scalable.
 .
 Cinder is the OpenStack Block storage service.
 .
 This package contains the Cinder backup service.

Package: cinder-common
Architecture: all
Depends:
 adduser,
 python-cinder (= ${binary:Version}),
 ${misc:Depends},
 ${python:Depends},
Recommends:
 ${misc:Recommends},
Provides:
 ${python:Provides},
Description: Cinder storage service - common files
 OpenStack is a reliable cloud infrastructure. Its mission is to produce
 the ubiquitous cloud computing platform that will meet the needs of public
 and private cloud providers regardless of size, by being simple to implement
 and massively scalable.
 .
 Cinder is the OpenStack Block storage service.
 .
 This package contains commons components for Cinder.

Package: cinder-scheduler
Architecture: all
Depends:
 cinder-common (= ${binary:Version}),
 ${misc:Depends},
 ${python:Depends},
Description: Cinder storage service - Scheduler server
 OpenStack is a reliable cloud infrastructure. Its mission is to produce
 the ubiquitous cloud computing platform that will meet the needs of public
 and private cloud providers regardless of size, by being simple to implement
 and massively scalable.
 .
 Cinder is the OpenStack Block storage service.
 .
 This package contains the Cinder Scheduler server.

Package: cinder-volume
Architecture: all
Depends:
 cinder-common (= ${binary:Version}),
 lvm2,
 qemu-utils,
 tgt,
 ${misc:Depends},
 ${python:Depends},
Breaks:
 cinder-common ( <= 2012.2~rc1~20120907.1154-0ubuntu1 ),
Replaces:
 cinder-common ( <= 2012.2~rc1~20120907.1154-0ubuntu1 ),
Description: Cinder storage service - Volume server
 OpenStack is a reliable cloud infrastructure. Its mission is to produce
 the ubiquitous cloud computing platform that will meet the needs of public
 and private cloud providers regardless of size, by being simple to implement
 and massively scalable.
 .
 Cinder is the OpenStack Block storage service.
 .
 This package contains the Cinder Volume server.

Package: python-cinder
Section: python
Architecture: all
Depends:
 python-babel (>= 2.3.4),
 python-barbicanclient (>= 4.0.0),
 python-castellan (>= 0.14.0),
 python-cryptography (>= 1.9),
 python-decorator (>= 3.4.0),
 python-defusedxml (>= 0.5.0),
 python-enum34,
 python-eventlet (>= 0.18.2),
 python-glanceclient (>= 1:2.8.0),
 python-greenlet (>= 0.4.10),
 python-httplib2 (>= 0.9.1),
 python-ipaddress (>= 1.0.16),
 python-iso8601 (>= 0.1.11),
 python-keystoneauth1 (>= 3.3.0),
 python-keystoneclient (>= 3.8.0),
 python-keystonemiddleware (>= 4.17.0),
 python-lxml (>= 3.4.1),
 python-migrate (>= 0.11.0),
 python-novaclient (>= 2:9.1.0),
 python-os-brick (>= 2.3.0-0ubuntu1.1~),
 python-os-win (>= 2.0.0),
 python-oslo.concurrency (>= 3.25.0),
 python-oslo.config (>= 1:5.1.0),
 python-oslo.context (>= 1:2.19.2),
 python-oslo.db (>= 4.27.0),
 python-oslo.i18n (>= 3.15.3),
 python-oslo.log (>= 3.36.0),
 python-oslo.messaging (>= 5.29.0),
 python-oslo.middleware (>= 3.31.0),
 python-oslo.policy (>= 1.30.0),
 python-oslo.privsep (>= 1.23.0),
 python-oslo.reports (>= 1.18.0),
 python-oslo.rootwrap (>= 5.8.0),
 python-oslo.serialization (>= 2.18.0),
 python-oslo.service (>= 1.24.0),
 python-oslo.utils (>= 3.33.0),
 python-oslo.versionedobjects (>= 1.31.2),
 python-oslo.vmware (>= 2.15.0),
 python-osprofiler (>= 1.3.0),
 python-paramiko (>= 2.0.0),
 python-paste (>= 2.0.2),
 python-pastedeploy (>= 1.5.0),
 python-prettytable (>= 0.7.1),
 python-pyparsing (>= 2.0.7),
 python-requests (>= 2.14.2),
 python-retrying (>= 1.2.3),
 python-routes (>= 2.3.1),
 python-simplejson (>= 3.5.1),
 python-six (>= 1.10.0),
 python-sqlalchemy (>= 1.0.10),
 python-stevedore (>= 1.20.0),
 python-suds,
 python-swiftclient (>= 1:3.2.0),
 python-taskflow (>= 1.26.0),
 python-tooz (>= 1.58.0),
 python-tz (>= 2013.6),
 python-webob (>= 1:1.7.1),
 ${misc:Depends},
 ${python:Depends},
Suggests:
 python-ceph,
 python-googleapi (>= 1.4.2),
 python-hp3parclient,
 python-oauth2client (>= 1.5.0),
 python-rtslib-fb,
Description: Cinder Python libraries
 OpenStack is a reliable cloud infrastructure. Its mission is to produce
 the ubiquitous cloud computing platform that will meet the needs of public
 and private cloud providers regardless of size, by being simple to implement
 and massively scalable.
 .
 Cinder is the OpenStack Block storage service.
 .
 This package contains the Python library for Cinder.

## cinder 13.0.0

=== debian/changelog ===
cinder (2:13.0.0-0ubuntu3) cosmic; urgency=medium

  * d/cinder-common.install: Install /etc/cinder/resource_filters.json

 -- Corey Bryant <corey.bryant@canonical.com>  Tue, 25 Sep 2018 09:42:11 -0400

cinder (2:13.0.0-0ubuntu2) cosmic; urgency=medium

  * d/rules: Ensure /usr/etc is purged from python{3}-cinder packages
    to resolve issues with co-installability.

 -- James Page <james.page@ubuntu.com>  Thu, 06 Sep 2018 10:24:56 +0100

cinder (2:13.0.0-0ubuntu1) cosmic; urgency=medium

  * New upstream release for OpenStack Rocky.

 -- Corey Bryant <corey.bryant@canonical.com>  Thu, 30 Aug 2018 10:21:32 -0400

cinder (2:13.0.0~rc3-0ubuntu1) cosmic; urgency=medium

  * d/cinder-common.apache2 -> d/cinder-api.apache2: Ensure that
    Apache2 configuration is installed with cinder-api (which has the
    right dependencies) rather than as part of the -common base package.
  * New upstream release candidate.

 -- James Page <james.page@ubuntu.com>  Thu, 30 Aug 2018 14:25:13 +0100

cinder (2:13.0.0~rc1-0ubuntu3) cosmic; urgency=medium

  * Additional support for Python 3:
    - d/control, d/cinder-*: Move common files to cinder-common. Only have
      python(3)-cinder depend on cinder-common. Other packages that used to
      depend on cinder-common now depend on python-cinder | python3-cinder.
    - d/control: Drop python(3)-cinder conflicts on each other.
    - d/python(3)-cinder.postinst: Ensure alternatives priority is 300
      for Py2 and 200 for Py3.
    - d/tests/control: Run Py3 tests first due to alternatives priority.

 -- Corey Bryant <corey.bryant@canonical.com>  Mon, 27 Aug 2018 13:07:52 -0400

cinder (2:13.0.0~rc1-0ubuntu2) cosmic; urgency=medium

  * d/control: Correct Suggests for python3-cinder from python3-ceph ->
    python3-{rbd,rados}, as python3-ceph does not exist.

 -- James Page <james.page@ubuntu.com>  Fri, 17 Aug 2018 07:59:43 +0100

cinder (2:13.0.0~rc1-0ubuntu1) cosmic; urgency=medium

  * New upstream release candidate for OpenStack Rocky.

 -- Corey Bryant <corey.bryant@canonical.com>  Fri, 10 Aug 2018 15:20:07 -0400

cinder (2:13.0.0~b3-0ubuntu1) cosmic; urgency=medium

  * New upstream milestone for OpenStack Rocky.
  * d/control: Align (Build-)Depends with upstream.

 -- Corey Bryant <corey.bryant@canonical.com>  Tue, 07 Aug 2018 16:14:02 -0400

cinder (2:13.0.0~b2-0ubuntu2) cosmic; urgency=medium

  * Add support for Python 3:
    - d/control: Add Py3 BDs and python3-cinder package.
    - d/control: Support Py2 first and Py3 as alternative.
    - d/control: Move all python deps to python(3)-cinder Depends.
    - d/control: Make python(3)-cinder conflict against each other.
    - d/rules: Add Py3 support.
    - d/rules: Use pkgos-dh_auto_install as this helps name binaries for
      update-alternatives.
    - d/python-cinder.install: Drop, not needed.
    - d/cinder*.install: Drop usr/bin/* as pkgos-dh_auto_install handles
      install of those files.
    - d/python(3)-cinder.post*, d/python(3)-cinder.prerm: Add update-alternatives
      to enable correct shebangs for Python binaries.
    - d/tests/*: Enable Py3 tests for cinder daemons and add shebang tests.
    - d/rules: Skip Py3.7 tests until they run successfully upstream.

 -- Corey Bryant <corey.bryant@canonical.com>  Fri, 06 Jul 2018 15:01:59 -0400

cinder (2:13.0.0~b2-0ubuntu1) cosmic; urgency=medium

  * New upstream milestone for OpenStack Rocky.
  * d/p/fix-migration.patch: Droped. Fixed in new milestone.

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 13 Jun 2018 12:46:53 -0400

cinder (2:13.0.0~b1-0ubuntu1) cosmic; urgency=medium

  * d/watch: Scope to 13.x series.
  * New upstream milestone for OpenStack Rocky.
  * d/control: Align (Build-)Depends with upstream.
  * d/control: Update Standards-Version to 4.1.4.
  * d/watch, d/control: Use https URLs.
  * d/control: Drop obsolete XS-Testsuite: autopkgtest header.
  * d/control, d/tests/*: Enable autopkgtest-pkg-python testsuite.
  * d/p/fix-sqlite3-migration-tests.patch: Cherry-picked from gerrit to
    fix DB migration error: https://review.openstack.org/#/c/570361/

 -- Corey Bryant <corey.bryant@canonical.com>  Fri, 18 May 2018 10:40:38 -0400

cinder (2:12.0.1-0ubuntu2) cosmic; urgency=medium

  * New upstream version.
  * d/p/log-config-options-with-oslo.config.patch: Dropped. Fixed in
    new upstream version.
  * New stable point release for OpenStack Queens (LP: #1767128).

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 02 May 2018 15:12:35 -0400

=== debian/tests/control ===
Tests: cinder-daemons cinder-volume cinder-shebangs-py3
Depends: python3-cinder, libapache2-mod-wsgi-py3,
 cinder-api, cinder-scheduler, lvm2
Restrictions: needs-root

Tests: cinder-daemons cinder-volume cinder-shebangs-py2
Depends: cinder-api, cinder-scheduler, lvm2
Restrictions: needs-root

=== debian/watch ===
version=3
opts="uversionmangle=s/\.([a-zA-Z])/~$1/;s/%7E/~/;s/\.0b/~b/;s/\.0rc/~rc/" \
 https://tarballs.openstack.org/cinder/ cinder-(13\.\d.*)\.tar\.gz

## cinder 13.0.1

=== requirements.txt ===
--- 
+++ 
@@ -7,18 +7,18 @@
 decorator>=3.4.0 # BSD
 defusedxml>=0.5.0 # PSF
 enum34>=1.0.4;python_version=='2.7' or python_version=='2.6' or python_version=='3.3' # BSD
-eventlet!=0.18.3,!=0.20.1,<0.21.0,>=0.18.2 # MIT
+eventlet!=0.18.3,!=0.20.1,>=0.18.2 # MIT
 greenlet>=0.4.10 # MIT
 httplib2>=0.9.1 # MIT
 iso8601>=0.1.11 # MIT
 jsonschema<3.0.0,>=2.6.0 # MIT
-ipaddress>=1.0.16;python_version<'3.3' # PSF
-keystoneauth1>=3.3.0 # Apache-2.0
+ipaddress>=1.0.17;python_version<'3.3' # PSF
+keystoneauth1>=3.4.0 # Apache-2.0
 keystonemiddleware>=4.17.0 # Apache-2.0
 lxml!=3.7.0,>=3.4.1 # BSD
 oauth2client!=4.0.0,>=1.5.0 # Apache-2.0
-oslo.config>=5.1.0 # Apache-2.0
-oslo.concurrency>=3.25.0 # Apache-2.0
+oslo.config>=5.2.0 # Apache-2.0
+oslo.concurrency>=3.26.0 # Apache-2.0
 oslo.context>=2.19.2 # Apache-2.0
 oslo.db>=4.27.0 # Apache-2.0
 oslo.log>=3.36.0 # Apache-2.0
@@ -39,7 +39,7 @@
 PrettyTable<0.8,>=0.7.1 # BSD
 psutil>=3.2.2 # BSD
 pyparsing>=2.1.0 # MIT
-python-barbicanclient!=4.5.0,!=4.5.1,>=4.0.0 # Apache-2.0
+python-barbicanclient>=4.5.2 # Apache-2.0
 python-glanceclient>=2.8.0 # Apache-2.0
 python-keystoneclient>=3.8.0 # Apache-2.0
 python-novaclient>=9.1.0 # Apache-2.0
@@ -49,7 +49,8 @@
 retrying!=1.3.0,>=1.2.3 # Apache-2.0
 Routes>=2.3.1 # MIT
 taskflow>=2.16.0 # Apache-2.0
-rtslib-fb!=2.1.60,!=2.1.61,!=2.1.64,>=2.1.43 # Apache-2.0
+rtslib-fb>=2.1.65 # Apache-2.0
+sphinx-feature-classification>=0.1.0 # Apache 2.0
 simplejson>=3.5.1 # MIT
 six>=1.10.0 # MIT
 SQLAlchemy!=1.1.5,!=1.1.6,!=1.1.7,!=1.1.8,>=1.0.10 # MIT
@@ -64,4 +65,5 @@
 tooz>=1.58.0 # Apache-2.0
 google-api-python-client>=1.4.2 # Apache-2.0
 castellan>=0.16.0 # Apache-2.0
-cryptography!=2.0,>=1.9 # BSD/Apache-2.0
+cryptography>=2.1 # BSD/Apache-2.0
+cursive>=0.2.1 # Apache-2.0

=== debian/changelog ===
cinder (2:13.0.1-5) unstable; urgency=medium

  * Check if /bin/ip is executable before using it in config script for
    autodetecting the value of my_ip (Clsoes: #914779).

 -- Thomas Goirand <zigo@debian.org>  Tue, 27 Nov 2018 14:05:07 +0100

cinder (2:13.0.1-4) unstable; urgency=medium

  * Add New_snapshot_clone_size_option.patch.

 -- Thomas Goirand <zigo@debian.org>  Thu, 22 Nov 2018 14:37:58 +0100

cinder (2:13.0.1-3) unstable; urgency=medium

  * Add Stop_masking_IOError_different_than_ENOSPC.patch.

 -- Thomas Goirand <zigo@debian.org>  Mon, 19 Nov 2018 11:53:39 +0100

cinder (2:13.0.1-2) unstable; urgency=medium

  * Rebuild with newer openstack-pkg-tools 89 

 -- Michal Arbet <michal.arbet@ultimum.io>  Mon, 12 Nov 2018 23:07:27 +0100

cinder (2:13.0.1-1) unstable; urgency=medium

  [ Michal Arbet ]
  * New upstream version
  * d/cinder-common.config.in:
  * d/cinder-common.postinst.in:
  * d/cinder-common.templates.in:
      - Handle glance_api_servers via debconf (Closes: #912992)
      - Handle my_ip via debconf (Closes: #912991)
      * Fix volume_group name in config (Closes: #912987)
  * d/cinder-common.postrm.in:
      - Fix deletion of policy.json (Closes: #912984)
  * d/rules: Make auth_strategy default to keystone
  * d/copyright: Add me to copyright file
  * d/control: Add me to uploaders field

 -- Michal Arbet <michal.arbet@ultimum.io>  Tue, 06 Nov 2018 13:57:47 +0100

cinder (2:13.0.0-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Wed, 05 Sep 2018 13:53:41 +0200

cinder (2:13.0.0-1) experimental; urgency=medium

  [ Thomas Goirand ]
  * Better init script descriptions.
  * New upstream release.
  * Fixed (build-)depends for this release.

  [ Ondřej Nový ]
  * d/control: Use team+openstack@tracker.debian.org as maintainer
  * d/changelog: Remove trailing whitespaces
  * Removed patches applied upstream:
    - Fix_python_version_check.patch
    - fix-sqlite3-migration-tests.patch
    - fix-netapp-unit-tests.patch
    - disable-unit-tests-bug-1715915.patch
    - fix-inspur-instorage-unit-tests.patch
    - fix-dell-emc-unit-tests.patch
    - fix-hpe3parfcdriver-unit-tests.patch
    - fix-rbd-driver-for-python3.patch

 -- Thomas Goirand <zigo@debian.org>  Fri, 15 Jun 2018 11:56:27 +0200

## cinder 13.0.2

=== debian/changelog ===
cinder (2:13.0.2-2) unstable; urgency=medium

  * Remove fix-qnap-unit-tests.patch
  * Add fix-python3-compatibility-ceph.patch

 -- Michal Arbet <michal.arbet@ultimum.io>  Wed, 06 Feb 2019 17:12:28 +0100

cinder (2:13.0.2-1) unstable; urgency=medium

  [ Thomas Goirand ]
  * Fix previous entry's typo that wrongly closed the bug.
  * New upstream release.

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces.

 -- Thomas Goirand <zigo@debian.org>  Thu, 17 Jan 2019 12:45:34 +0100

=== debian/control ===
Source: cinder
Section: net
Priority: optional
Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
 Michal Arbet <michal.arbet@ultimum.io>,
Build-Depends:
 debhelper (>= 10),
 dh-python,
 openstack-pkg-tools (>= 89~),
 po-debconf,
 python3-all,
 python3-pbr (>= 2.0.0),
 python3-setuptools,
 python3-sphinx (>= 1.6.2),
Build-Depends-Indep:
 bandit (>= 0.13.2),
 python3-babel,
 python3-barbicanclient (>= 4.5.2),
 python3-castellan (>= 0.16.0),
 python3-coverage,
 python3-cryptography (>= 2.1),
 python3-cursive (>= 0.2.1),
 python3-ddt (>= 1.0.1),
 python3-decorator (>= 3.4.0),
 python3-defusedxml (>= 0.5.0),
 python3-eventlet (>= 0.18.4),
 python3-fixtures,
 python3-glanceclient (>= 1:2.8.0),
 python3-googleapi (>= 1.4.2),
 python3-greenlet,
 python3-hacking (>= 0.10.0),
 python3-httplib2,
 python3-iso8601 (>= 0.1.11),
 python3-jsonschema (>= 2.6.0),
 python3-keystoneauth1 (>= 3.4.0),
 python3-keystoneclient (>= 1:3.8.0),
 python3-keystonemiddleware (>= 4.17.0),
 python3-lxml,
 python3-migrate (>= 0.11.0),
 python3-mock,
 python3-mysqldb,
 python3-novaclient (>= 2:9.1.0),
 python3-oauth2client,
 python3-openstackdocstheme (>= 1.18.1),
 python3-os-api-ref (>= 1.4.0),
 python3-os-brick (>= 2.2.0),
 python3-os-win (>= 3.0.0),
 python3-oslo.concurrency (>= 3.26.0),
 python3-oslo.config (>= 1:5.2.0),
 python3-oslo.context (>= 2.19.2),
 python3-oslo.db (>= 4.27.0),
 python3-oslo.i18n (>= 3.15.3),
 python3-oslo.log (>= 3.36.0),
 python3-oslo.messaging (>= 5.29.0),
 python3-oslo.middleware (>= 3.31.0),
 python3-oslo.policy (>= 1.30.0),
 python3-oslo.privsep (>= 1.23.0),
 python3-oslo.reports (>= 1.18.0),
 python3-oslo.rootwrap (>= 5.8.0),
 python3-oslo.serialization (>= 2.18.0),
 python3-oslo.service (>= 1.28.1),
 python3-oslo.utils (>= 3.33.0),
 python3-oslo.versionedobjects (>= 1.31.2),
 python3-oslo.vmware (>= 2.17.0),
 python3-oslotest (>= 1:3.2.0),
 python3-osprofiler (>= 1.4.0),
 python3-paramiko (>= 2.0),
 python3-paste,
 python3-pastedeploy,
 python3-pep8,
 python3-prettytable,
 python3-psutil,
 python3-psycopg2 (>= 2.6.2),
 python3-pymysql,
 python3-pyparsing,
 python3-requests (>= 2.14.2),
 python3-retrying,
 python3-routes,
 python3-rtslib-fb (>= 2.1.65),
 python3-simplejson,
 python3-six (>= 1.9.0),
 python3-sphinx-feature-classification,
 python3-sphinxcontrib.apidoc,
 python3-sqlalchemy (>= 1.0.10),
 python3-stestr,
 python3-stevedore (>= 1.20.0),
 python3-swiftclient (>= 1:3.2.0),
 python3-taskflow (>= 2.16.0),
 python3-tempest (>= 1:17.1.0),
 python3-testresources (>= 2.0.0),
 python3-testscenarios,
 python3-testtools (>= 2.2.0),
 python3-tooz (>= 1.58.0),
 python3-tz,
 python3-webob (>= 1.7.1),
 subunit,
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/openstack-team/services/cinder
Vcs-Git: https://salsa.debian.org/openstack-team/services/cinder.git
Homepage: https://github.com/openstack/cinder

Package: cinder-api
Architecture: all
Depends:
 adduser,
 cinder-common (= ${binary:Version}),
 debconf,
 python3-keystoneclient,
 python3-openstackclient,
 python3-pastescript,
 q-text-as-data,
 thin-provisioning-tools,
 uwsgi-plugin-python3,
 ${misc:Depends},
 ${ostack-lsb-base},
 ${python3:Depends},
Description: OpenStack block storage system - API server
 Cinder is a block Storage-as-a-Service system for the OpenStack cloud
 computing suite. It re-implements the features of Nova-volume, which it
 directly replaces.
 .
 Cinder uses LVM partitions of your volume servers in order to provide iSCSI
 permanent block storage devices for your virtual machines running on Nova.
 It also has back-end drivers for many hardware and software storage solutions
 like Ceph, NFS, Net-APP, etc.
 .
 This package contains the Cinder API server.

Package: cinder-backup
Architecture: all
Depends:
 adduser,
 cinder-common (= ${binary:Version}),
 ${misc:Depends},
 ${ostack-lsb-base},
 ${python3:Depends},
Description: OpenStack block storage system - Backup server
 Cinder is a block Storage-as-a-Service system for the OpenStack cloud
 computing suite. It re-implements the features of Nova-volume, which it
 directly replaces.
 .
 Cinder uses LVM partitions of your volume servers in order to provide iSCSI
 permanent block storage devices for your virtual machines running on Nova.
 It also has back-end drivers for many hardware and software storage solutions
 like Ceph, NFS, Net-APP, etc.
 .
 This package contains the Cinder backup service.

Package: cinder-common
Architecture: all
Depends:
 adduser,
 dbconfig-common,
 debconf,
 python3-cinder (= ${binary:Version}),
 sqlite3,
 ${misc:Depends},
 ${python3:Depends},
Provides:
 ${python:Provides},
Description: OpenStack block storage system - common files
 Cinder is a block Storage-as-a-Service system for the OpenStack cloud
 computing suite. It re-implements the features of Nova-volume, which it
 directly replaces.
 .
 Cinder uses LVM partitions of your volume servers in order to provide iSCSI
 permanent block storage devices for your virtual machines running on Nova.
 It also has back-end drivers for many hardware and software storage solutions
 like Ceph, NFS, Net-APP, etc.
 .
 This package contains common files and configuration that are
 needed by all the daemon packages of Cinder.

Package: cinder-doc
Architecture: all
Build-Profiles: <!nodoc>
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: OpenStack block storage system - doc
 Cinder is a block Storage-as-a-Service system for the OpenStack cloud
 computing suite. It re-implements the features of Nova-volume, which it
 directly replaces.
 .
 Cinder uses LVM partitions of your volume servers in order to provide iSCSI
 permanent block storage devices for your virtual machines running on Nova.
 It also has back-end drivers for many hardware and software storage
 solutions
 like Ceph, NFS, Net-APP, etc.
 .
 This package contains the documentation.

Package: cinder-scheduler
Architecture: all
Depends:
 cinder-common (= ${binary:Version}),
 ${misc:Depends},
 ${ostack-lsb-base},
 ${python3:Depends},
Description: OpenStack block storage system - Scheduler server
 Cinder is a block Storage-as-a-Service system for the OpenStack cloud
 computing suite. It re-implements the features of Nova-volume, which it
 directly replaces.
 .
 Cinder uses LVM partitions of your volume servers in order to provide iSCSI
 permanent block storage devices for your virtual machines running on Nova.
 It also has back-end drivers for many hardware and software storage solutions
 like Ceph, NFS, Net-APP, etc.
 .
 This package contains the Cinder Scheduler server.

Package: cinder-volume
Architecture: all
Depends:
 adduser,
 cinder-common (= ${binary:Version}),
 lvm2,
 qemu-utils,
 tgt | open-iscsi,
 ${misc:Depends},
 ${ostack-lsb-base},
 ${python3:Depends},
Suggests:
 ceph-common,
Description: OpenStack block storage system - Volume server
 Cinder is a block Storage-as-a-Service system for the OpenStack cloud
 computing suite. It re-implements the features of Nova-volume, which it
 directly replaces.
 .
 Cinder uses LVM partitions of your volume servers in order to provide iSCSI
 permanent block storage devices for your virtual machines running on Nova.
 It also has back-end drivers for many hardware and software storage solutions
 like Ceph, NFS, Net-APP, etc.
 .
 This package contains the Cinder Volume server.

Package: python3-cinder
Section: python
Architecture: all
Depends:
 python3-babel,
 python3-barbicanclient (>= 4.5.2),
 python3-castellan (>= 0.16.0),
 python3-cryptography (>= 2.1),
 python3-cursive (>= 0.2.1),
 python3-decorator (>= 3.4.0),
 python3-defusedxml (>= 0.5.0),
 python3-eventlet (>= 0.18.4),
 python3-glanceclient (>= 1:2.8.0),
 python3-googleapi (>= 1.4.2),
 python3-greenlet,
 python3-httplib2,
 python3-iso8601 (>= 0.1.11),
 python3-jsonschema (>= 2.6.0),
 python3-keystoneauth1 (>= 3.4.0),
 python3-keystoneclient (>= 1:3.8.0),
 python3-keystonemiddleware (>= 4.17.0),
 python3-lxml,
 python3-migrate (>= 0.11.0),
 python3-mysqldb,
 python3-novaclient (>= 2:9.1.0),
 python3-oauth2client,
 python3-os-brick (>= 2.2.0),
 python3-os-win (>= 3.0.0),
 python3-oslo.concurrency (>= 3.26.0),
 python3-oslo.config (>= 1:5.2.0),
 python3-oslo.context (>= 2.19.2),
 python3-oslo.db (>= 4.27.0),
 python3-oslo.i18n (>= 3.15.3),
 python3-oslo.log (>= 3.36.0),
 python3-oslo.messaging (>= 5.29.0),
 python3-oslo.middleware (>= 3.31.0),
 python3-oslo.policy (>= 1.30.0),
 python3-oslo.privsep (>= 1.23.0),
 python3-oslo.reports (>= 1.18.0),
 python3-oslo.rootwrap (>= 5.8.0),
 python3-oslo.serialization (>= 2.18.0),
 python3-oslo.service (>= 1.28.1),
 python3-oslo.utils (>= 3.33.0),
 python3-oslo.versionedobjects (>= 1.31.2),
 python3-oslo.vmware (>= 2.17.0),
 python3-osprofiler (>= 1.4.0),
 python3-paramiko (>= 2.0),
 python3-paste,
 python3-pastedeploy,
 python3-pbr (>= 2.0.0),
 python3-prettytable,
 python3-psutil,
 python3-psycopg2 (>= 2.6.2),
 python3-pymysql,
 python3-pyparsing,
 python3-requests (>= 2.14.2),
 python3-retrying,
 python3-routes,
 python3-rtslib-fb (>= 2.1.65),
 python3-simplejson,
 python3-six (>= 1.9.0),
 python3-sqlalchemy (>= 1.0.10),
 python3-stevedore (>= 1.20.0),
 python3-swiftclient (>= 1:3.2.0),
 python3-taskflow (>= 2.16.0),
 python3-tooz (>= 1.58.0),
 python3-tz,
 python3-webob (>= 1.7.1),
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 python3-ceph,
 python3-hp3parclient,
Description: OpenStack block storage system - Python libraries
 Cinder is a block Storage-as-a-Service system for the OpenStack cloud
 computing suite. It re-implements the features of Nova-volume, which it
 directly replaces.
 .
 Cinder uses LVM partitions of your volume servers in order to provide iSCSI
 permanent block storage devices for your virtual machines running on Nova.
 It also has back-end drivers for many hardware and software storage solutions
 like Ceph, NFS, Net-APP, etc.
 .
 This package contains the Python libraries that are part of Cinder.

## cinder 13.0.3

=== requirements.txt ===
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.
openstackdocstheme>=1.18.1 # Apache-2.0
reno>=2.5.0 # Apache-2.0
doc8>=0.6.0 # Apache-2.0
sphinx!=1.6.6,!=1.6.7,>=1.6.2 # BSD
mock>=2.0.0 # BSD
os-api-ref>=1.4.0 # Apache-2.0
ddt>=1.0.1 # MIT
fixtures>=3.0.0 # Apache-2.0/BSD
sphinxcontrib-apidoc>=0.2.0  # BSD

=== block-box/Makefile ===
CINDER_BRANCH ?= master# master, stable/ocata, refs/changes/67/418167/1
NAME_PREFIX ?= ""
PLATFORM ?= debian:stretch# ubuntu:xenial, centos:7
TAG ?= debian-cinder:latest

all: base lvm
blockbox: base lvm

base:
	docker build https://git.openstack.org/openstack/loci.git \
		--build-arg PROJECT=cinder \
		--build-arg FROM=$(PLATFORM) \
		--build-arg PROJECT_REF=$(CINDER_BRANCH) \
		--tag $(TAG)
lvm:
	docker build https://git.openstack.org/openstack/loci.git \
		--build-arg PROJECT=cinder \
		--build-arg FROM=$(PLATFORM) \
		--build-arg PROJECT_REF=$(CINDER_BRANCH) \
		--build-arg PROFILES="lvm" \
		--tag lvm-$(TAG)

=== debian/changelog ===
cinder (2:13.0.3-1) unstable; urgency=medium

  * New upstream version
  * Remove upstream aplied patch
    - Stop_masking_IOError_different_than_ENOSPC.patch

 -- Michal Arbet <michal.arbet@ultimum.io>  Tue, 26 Feb 2019 11:30:22 +0100

cinder (2:13.0.2-3) unstable; urgency=medium

  * Update fix-python3-compatibility-ceph.patch
  * Add ceph-common to recommends

 -- Michal Arbet <michal.arbet@ultimum.io>  Tue, 26 Feb 2019 10:42:13 +0100

=== debian/control ===
--- 
+++ 
@@ -309,6 +309,7 @@
  ${python3:Depends},
 Recommends:
  python3-ceph,
+ ceph-common,
  python3-hp3parclient,
 Description: OpenStack block storage system - Python libraries
  Cinder is a block Storage-as-a-Service system for the OpenStack cloud

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/openstack-pkg-tools/pkgos.make

%:
	dh $@ --buildsystem=python_distutils --with python3,systemd,sphinxdoc

override_dh_clean:
	dh_clean
	rm -f debian/cinder-common.config debian/cinder-common.postinst debian/cinder-api.config debian/cinder-api.postinst debian/cinder-volume.postinst debian/cinder-common.postrm
	rm -rf debian/*.upstart debian/*.service debian/*.templates
	if [ -e debian/po-backup ] ; then \
		rm -rf debian/po ; \
		mv debian/po-backup debian/po ; \
	fi
	rm -rf build
	find . -name '*.pyc' -delete
	rm -rf .stestr
	rm -rf cinder.egg-info
	rm -f AUTHORS ChangeLog

override_dh_auto_clean:
	echo "Do nothing..."

override_dh_auto_install:
	echo "Do nothing..."

override_dh_auto_test:
	echo "Do nothing..."

override_dh_auto_build:
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-common.config
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-common.postinst
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-api.config
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-api.postinst
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func cinder-volume.postinst
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_postrm cinder-common.postrm
	cp -auxf debian/po debian/po-backup
	pkgos-merge-templates cinder-api cinder endpoint
	pkgos-merge-templates cinder-common cinder db rabbit ksat

override_dh_install:
	python3 setup.py install --install-layout=deb --root $(CURDIR)/debian/tmp
	rm -rf $(CURDIR)/debian/tmp/usr/etc

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	for i in $(PYTHON3S) ; do \
		PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages PYTHON=python$$i python3-stestr run  | subunit2pyunit ; \
	done
endif

	mkdir -p $(CURDIR)/debian/cinder-common/usr/share/cinder-common
	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages python3-oslo-config-generator \
		--output-file $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf \
		--wrap-width 140 \
		--namespace castellan.config \
		--namespace cinder \
		--namespace keystonemiddleware.auth_token \
		--namespace osprofiler \
		--namespace oslo.config \
		--namespace oslo.concurrency \
		--namespace oslo.db \
		--namespace oslo.log \
		--namespace oslo.messaging \
		--namespace oslo.middleware \
		--namespace oslo.policy \
		--namespace oslo.reports \
		--namespace oslo.service.periodic_task \
		--namespace oslo.service.service \
		--namespace oslo.service.sslutils \
		--namespace oslo.service.wsgi \
		--namespace oslo.versionedobjects
	pkgos-readd-keystone-authtoken-missing-options $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf keystone_authtoken cinder

	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages python3-oslopolicy-sample-generator \
		--output-file $(CURDIR)/debian/cinder-common/usr/share/cinder-common/policy.json \
		--format json \
		--namespace cinder

	dh_install
	dh_missing --fail-missing -Xbin/cinder-all
	install -D -m 0440 debian/cinder-common.sudoers $(CURDIR)/debian/cinder-common/etc/sudoers.d/cinder-common

	pkgos-fix-config-default $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf DEFAULT auth_strategy keystone

	# Set LVM as default backend
	pkgos-fix-config-default $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf DEFAULT enabled_backends lvm
	echo "[lvm]" 				>> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf
	echo "volume_driver = cinder.volume.drivers.lvm.LVMVolumeDriver" >> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf
	echo "volume_group = pkgosvg0" 		>> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf
	echo "iscsi_protocol = iscsi" 		>> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf
	echo "iscsi_helper = tgtadm" 		>> $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf

	# Set a default value for lock_path & state_path
	pkgos-fix-config-default $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf oslo_concurrency lock_path /var/lock/cinder

	# Fix the missing sql_connection directive
	pkgos-fix-config-default $(CURDIR)/debian/cinder-common/usr/share/cinder-common/cinder.conf database sqlite:////var/lib/cinder/cinderdb

	install -D -m 0644 $(CURDIR)/etc/cinder/logging_sample.conf $(CURDIR)/debian/cinder-common/usr/share/cinder-common/logging.conf

override_dh_fixperms:
	dh_fixperms -Xcinder_tgt.conf
	chmod 0440 $(CURDIR)/debian/cinder-common/etc/sudoers.d/cinder-common

override_dh_sphinxdoc:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	PYTHONPATH=$(CURDIR)/debian/python3-cinder/usr/lib/python3/dist-packages PYTHON=python3 python3 -m sphinx -b html doc/source $(CURDIR)/debian/cinder-doc/usr/share/doc/cinder-doc/html
	dh_sphinxdoc
endif

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3
